wxWidgets: wxFileHistory Class Reference

| Version: 3.0.2

- Main Page
- Related Pages
- Categories
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | List of all members
wxFileHistory Class Reference
Document/View Framework

`#include <wx/filehistory.h>`

Inheritance diagram for wxFileHistory:
[legend]

## Detailed Description

The wxFileHistory encapsulates a user interface convenience, the list of most recently visited files as shown on a menu (usually the File menu).

wxFileHistory can manage one or more file menus. More than one menu may be required in an MDI application, where the file history should appear on each MDI child menu as well as the MDI parent frame.

##

Library: wxCore
Category: Document/View Framework

See Also
  Document/View Framework, wxDocManager

## Public Member Functions
| wxFileHistory (size_t maxFiles=9, wxWindowID idBase=wxID_FILE1)
| Constructor.
virtual | ~wxFileHistory ()
| Destructor.
virtual void | AddFileToHistory (const wxString &filename)
| Adds a file to the file history list, if the object has a pointer to an appropriate file menu.
virtual void | AddFilesToMenu ()
| Appends the files in the history list, to all menus managed by the file history object.
virtual void | AddFilesToMenu (wxMenu *menu)
| Appends the files in the history list, to the given menu only.
wxWindowID | GetBaseId () const
| Returns the base identifier for the range used for appending items.
virtual size_t | GetCount () const
| Returns the number of files currently stored in the file history.
virtual wxString | GetHistoryFile (size_t index) const
| Returns the file at this index (zero-based).
virtual int | GetMaxFiles () const
| Returns the maximum number of files that can be stored.
const wxList & | GetMenus () const
| Returns the list of menus that are managed by this file history object.
virtual void | Load (const wxConfigBase &config)
| Loads the file history from the given config object.
virtual void | RemoveFileFromHistory (size_t i)
| Removes the specified file from the history.
virtual void | RemoveMenu (wxMenu *menu)
| Removes this menu from the list of those managed by this object.
virtual void | Save (wxConfigBase &config)
| Saves the file history into the given config object.
void | SetBaseId (wxWindowID baseId)
| Sets the base identifier for the range used for appending items.
virtual void | UseMenu (wxMenu *menu)
| Adds this menu to the list of those menus that are managed by this file history object.
Public Member Functions inherited from wxObject
| wxObject ()
| Default ctor; initializes to NULL the internal reference data.
| wxObject (const wxObject &other)
| Copy ctor.
virtual | ~wxObject ()
| Destructor.
virtual wxClassInfo * | GetClassInfo () const
| This virtual function is redefined for every class that requires run-time type information, when using the wxDECLARE_CLASS macro (or similar).
wxObjectRefData * | GetRefData () const
| Returns the wxObject::m_refData pointer, i.e. the data referenced by this object.
bool | IsKindOf (const wxClassInfo *info) const
| Determines whether this class is a subclass of (or the same class as) the given class.
bool | IsSameAs (const wxObject &obj) const
| Returns true if this object has the same data pointer as obj.
void | Ref (const wxObject &clone)
| Makes this object refer to the data in clone.
void | SetRefData (wxObjectRefData *data)
| Sets the wxObject::m_refData pointer.
void | UnRef ()
| Decrements the reference count in the associated data, and if it is zero, deletes the data.
void | UnShare ()
| This is the same of AllocExclusive() but this method is public.
void | operator delete (void *buf)
| The delete operator is defined for debugging versions of the library only, when the identifier `WXDEBUG` is defined.
void * | operator new (size_t size, const wxString &filename=NULL, int lineNum=0)
| The new operator is defined for debugging versions of the library only, when the identifier `WXDEBUG` is defined.

## Additional Inherited Members
Protected Member Functions inherited from wxObject
void | AllocExclusive ()
| Ensure that this object's data is not shared with any other object.
virtual wxObjectRefData * | CreateRefData () const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and returns it.
virtual wxObjectRefData * | CloneRefData (const wxObjectRefData *data) const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and initializes it copying data.
Protected Attributes inherited from wxObject
wxObjectRefData * | m_refData
| Pointer to an object which is the object's reference-counted data.

## Constructor & Destructor Documentation

wxFileHistory::wxFileHistory | ( | size_t | maxFiles = `9`,
|  | wxWindowID | idBase = `wxID_FILE1`
| ) |  |

Constructor.

Pass the maximum number of files that should be stored and displayed.

idBase defaults to wxID_FILE1 and represents the id given to the first history menu item. Since menu items can't share the same ID you should change idBase (to one of your own defined IDs) when using more than one wxFileHistory in your application.

virtual wxFileHistory::~wxFileHistory | ( |  | ) |
| virtual

Destructor.

## Member Function Documentation

virtual void wxFileHistory::AddFilesToMenu | ( |  | ) |
| virtual

Appends the files in the history list, to all menus managed by the file history object.

virtual void wxFileHistory::AddFilesToMenu | ( | wxMenu * | menu | ) |
| virtual

Appends the files in the history list, to the given menu only.

virtual void wxFileHistory::AddFileToHistory | ( | const wxString & | filename | ) |
| virtual

Adds a file to the file history list, if the object has a pointer to an appropriate file menu.

wxWindowID wxFileHistory::GetBaseId | ( |  | ) | const

Returns the base identifier for the range used for appending items.

virtual size_t wxFileHistory::GetCount | ( |  | ) | const
| virtual

Returns the number of files currently stored in the file history.

virtual wxString wxFileHistory::GetHistoryFile | ( | size_t | index | ) | const
| virtual

Returns the file at this index (zero-based).

virtual int wxFileHistory::GetMaxFiles | ( |  | ) | const
| virtual

Returns the maximum number of files that can be stored.

const wxList& wxFileHistory::GetMenus | ( |  | ) | const

Returns the list of menus that are managed by this file history object.

See Also
  UseMenu()

virtual void wxFileHistory::Load | ( | const wxConfigBase & | config | ) |
| virtual

Loads the file history from the given config object.

This function should be called explicitly by the application.

See Also
  wxConfigBase

virtual void wxFileHistory::RemoveFileFromHistory | ( | size_t | i | ) |
| virtual

Removes the specified file from the history.

virtual void wxFileHistory::RemoveMenu | ( | wxMenu * | menu | ) |
| virtual

Removes this menu from the list of those managed by this object.

virtual void wxFileHistory::Save | ( | wxConfigBase & | config | ) |
| virtual

Saves the file history into the given config object.

This must be called explicitly by the application.

See Also
  wxConfigBase

void wxFileHistory::SetBaseId | ( | wxWindowID | baseId | ) |

Sets the base identifier for the range used for appending items.

virtual void wxFileHistory::UseMenu | ( | wxMenu * | menu | ) |
| virtual

Adds this menu to the list of those menus that are managed by this file history object.

Also see AddFilesToMenu() for initializing the menu with filenames that are already in the history when this function is called, as this is not done automatically.